C     -----------------------------------------------------------------
C
C*    Control variables for RADIATION: fluxes and satellite radiances
C
C NMODE :  CONFIGURATION INDEX FOR THE RADIATION CODE
C NFLUX :  NUMBER OF RADIATIVE FLUXES
C NRAD  :  NUMBER OF RADIANCES
C NAER  :  CONFIGURATION INDEX FOR AEROSOLS
C NGEO  :  NUMBER OF GEOSTATIONARY SATELLITES
C NPOLO :  NUMBER OF POLAR-ORBITER SATELLITES
C LGEOSE:  SWITCH FOR GEOS-EAST
C LGEOSW:  SWITCH FOR GEOS-WEST
C LGMS  :  SWITCH FOR GMS
C LINDSA:  SWITCH FOR INDSAT
C LMTO  :  SWITCH FOR METEOSAT
C LNOAA :  SWITCH FOR NOAA-A
C LNOAB :  SWITCH FOR NOAA-B
C LNOAC :  SWITCH FOR NOAA-C
C LNOAD :  SWITCH FOR NOAA-D
C
      COMMON/YOMRAD/NMODE,NFLUX,NRAD,NAER,NGEO,NPOLO
     S             ,LGEOSE,LGEOSW,LGMS,LINDSA,LMTO
     S             ,LNOAA,LNOAB,LNOAC,LNOAD

      integer nmode,nflux,nrad,naer,ngeo,npolo
     .       ,lgeose,lgeosw,lgms,lindsa,lmto
     .       ,lnoaa,lnoab,lnoac,lnoad
C     -----------------------------------------------------------------
