      SUBROUTINE surfini(ngrid,piceco2,psolaralb)
      IMPLICIT NONE
c=======================================================================
c
c   creation des calottes pour l'etat initial
c
c=======================================================================
c-----------------------------------------------------------------------
c   Declarations:
c   -------------
#include "dimensions.h"
#include "dimphys.h"
#include "surfdat.h"
c
      INTEGER ngrid,ig,icap
      REAL  piceco2(ngrid),psolaralb(ngrid,2)

      EXTERNAL ISMIN,ISMAX
      INTEGER ISMIN,ISMAX
c
c=======================================================================

c
c     calcul de piceco2 (kg/m2) a l'etat initial
c     ------------------------------------------

      DO 100 ig=1,ngrid
         psolaralb(ig,1)=albedodat(ig)
         psolaralb(ig,2)=albedodat(ig)
100   CONTINUE

      PRINT*,'minimum des donnees albedo',
     s     albedodat(ISMIN(ngrid,albedodat,1))
      PRINT*,'maximum des donnees albedo',
     s     albedodat(ISMAX(ngrid,albedodat,1))
c      calcul de psolaralb 
c      -------------------
      DO 115 ig=1,ngrid
         IF (piceco2(ig) .GT. 0.) THEN
             IF(ig.GT.ngrid/2+1) THEN
                icap=2
             ELSE
                icap=1
             ENDIF
             psolaralb(ig,1) = albedice(icap)
             psolaralb(ig,2) =  albedice(icap)
         END IF
115   CONTINUE      

      PRINT*,'minimum des donnees albedo',
     s     psolaralb(ISMIN(ngrid,psolaralb,1),1)
      PRINT*,'maximum des donnees albedo',
     s     psolaralb(ISMAX(ngrid,psolaralb,1),1)

      RETURN
      END
