c *************************************************************
c Subroutine reading database CO2 ground ice temperatures
c *********************************
c  Francois FORGET , 1993
 
      subroutine xinitsurfco2(Tsurf,NORTH,imax,jmax)


      IMPLICIT NONE

c  *********************
c  VARIABLES DECLARATION :
c  *********************
      integer imax, jmax
      real Tsurf (imax,jmax)

      integer n, i,j
c Data :
      real lat,lon,T

c true if studied aera is the north Hemisphere
      logical NORTH
  

c    INITIALIZATION
c   """""""""""""""
      if (NORTH) then
        open (46, file ='nor.tsurf',status='old')
      else
        open (46, file ='sud.tsurf',status='old')
      end if
       do n =1, imax*jmax
          read (46,*) j,i,lat,lon,T
          Tsurf(i,j) = T
       end  do
       close (46)
       end 
